var atoum = require('../../..')(module),
    testedClass = require('../../../lib/test/mock/controller'),
    unit = module.exports = {
        testClass: function() {
            var object, mock;

            this
                .if(mock = {})
                .then()
                    .object(object = new testedClass(mock))
                    .object(object.mock).isIdenticalTo(mock)
                    .object(object.args).isEmpty()
            ;
        },

        testRun: function() {
            var controller, mockInstance, returned, method, args;

            this
                .if(returned = Math.random().toString(36).substring(7))
                .and(mockInstance = {
                    "method": method = this.generateCallback(function () { return returned; })
                })
                .and(controller = new testedClass(mockInstance))
                .then()
                    .variable(controller.run('method', method)).isIdenticalTo(returned)
                    .callback(mockInstance.method).wasCalled().withoutArgument()
                    .object(controller.args).hasLength(1).hasMember('method')
                    .array(controller.args.method).hasLength(1)
                    .array(controller.args.method[0]).isEmpty()
                .if(args = ['foo', 'bar'])
                .then()
                    .variable(controller.run('method', method, args)).isIdenticalTo(returned)
                    .callback(mockInstance.method).wasCalled().withArguments(args[0], args[1])
                    .object(controller.args).hasLength(1).hasMember('method')
                    .array(controller.args.method).hasLength(2)
                    .array(controller.args.method[1]).isEqualTo(args)
            ;
        },

        testOverride: function() {
            var controller, mockInstance, method, overridden, unknown, otherMethod;

            this
                .if(mockInstance = { "method": method = this.generateCallback() })
                .and(controller = new testedClass(mockInstance))
                .then()
                    .object(controller.override('method', overridden = this.generateCallback(function() { return this; }))).isIdenticalTo(controller)
                    .object(controller.run('method', method)).isIdenticalTo(mockInstance)
                    .callback(method).wasNotCalled()
                    .callback(overridden).wasCalled().withoutArgument()
                .if(controller = new testedClass(mockInstance))
                .and(controller.override('unknown', unknown = this.generateCallback(function() { return this; })))
                .then()
                    .object(controller.run('unknown')).isIdenticalTo(mockInstance)
                    .callback(unknown).wasCalled().withoutArgument()
                .if(mockInstance = { "method": this.generateCallback() })
                .and(controller = new testedClass(mockInstance))
                .and(mockInstance.controller = controller)
                .and(controller.override('method', method = this.generateCallback(function() { return this; })))
                .then()
                    .object(controller.run('method')).isIdenticalTo(mockInstance)
                    .callback(method).wasCalled().withoutArgument()
                .if(mockInstance = { "method": this.generateCallback() })
                .and(controller = new testedClass(mockInstance))
                .and(mockInstance.controller = controller)
                .and(controller.override('method', method = this.generateCallback(function() { return this; })))
                .and(controller.override('method', otherMethod = this.generateCallback(function() { return "foo"; }), 2))
                .then()
                    .object(controller.run('method')).isIdenticalTo(mockInstance)
                    .callback(method).wasCalled().withoutArgument()
                    .callback(otherMethod).wasNotCalled()
                .if(controller.run('method'))
                .then()
                    .callback(otherMethod).wasCalled().withoutArgument()
                .if(controller.override('method', overridden = Math.random().toString(36).substring(7)))
                .then()
                    .variable(controller.run('method')).isIdenticalTo(overridden)
            ;
        }
    };
